/* $Id: main.h,v 1.5 1998/02/20 21:14:15 hjlee Exp $ */
/****************************************************************************/
/*   MPEG4 Visual Texture Coding (VTC) Mode Software                        */
/*                                                                          */
/*   This software was developed by                                         */
/*   Sarnoff Coporation                   and    Texas Instruments          */
/*   Iraj Sodagar   (iraj@sarnoff.com)           Jie Liang (liang@ti.com)   */
/*   Hung-Ju Lee    (hjlee@sarnoff.com)                                     */
/*   Paul Hatrack   (hatrack@sarnoff.com)                                   */
/*   Shipeng Li     (shipeng@sarnoff.com)                                   */
/*   Bing-Bing Chai (bchai@sarnoff.com)                                     */
/*                                                                          */
/* In the course of development of the MPEG-4 standard. This software       */
/* module is an implementation of a part of one or more MPEG-4 tools as     */
/* specified by the MPEG-4 standard.                                        */
/*                                                                          */
/* The copyright of this software belongs to ISO/IEC. ISO/IEC gives use     */
/* of the MPEG-4 standard free license to use this  software module or      */
/* modifications thereof for hardware or software products claiming         */
/* conformance to the MPEG-4 standard.                                      */
/*                                                                          */
/* Those intending to use this software module in hardware or software      */
/* products are advised that use may infringe existing  patents. The        */
/* original developers of this software module and their companies, the     */
/* subsequent editors and their companies, and ISO/IEC have no liability    */
/* and ISO/IEC have no liability for use of this software module or         */
/* modification thereof in an implementation.                               */
/*                                                                          */
/* Permission is granted to MPEG memebers to use, copy, modify,             */
/* and distribute the software modules ( or portions thereof )              */
/* for standardization activity within ISO/IEC JTC1/SC29/WG11.              */
/*                                                                          */
/* Copyright (C) 1998  Sarnoff Coporation and Texas Instruments             */ 
/****************************************************************************/

/************************************************************/
/*     Sarnoff Very Low Bit Rate Still Image Coder          */
/*     Copyright 1995, 1996, 1997, 1998 Sarnoff Corporation */
/************************************************************/

#ifndef _MAIN_H_
#define _MAIN_H_

#ifndef _DATA_STRUCT_H_
#include "dataStruct.h"
#endif _DATA_STRUCT_H


/*--- read_control_file.c ---*/
void read_control_file(char *ctlfname, SOL_PARAMETERS *vm_param);
void read_control_file_dec(char *ctlfname, SOL_PARAMETERS_DEC *vm_param);
void free_vm_param( SOL_PARAMETERS *vm_param);
void free_vm_param_dec( SOL_PARAMETERS_DEC *vm_param_dec);

/*--- read_image.c ---*/
void read_image(char *img_path, int img_width, int img_height, 
		int img_colors, int img_bit_depth,
		PICTURE *img);

/*--- seg.c ---*/
int read_segimage(char *seg_path, int seg_width, int seg_height, 
		  int img_colors, int img_bit_depth,
		  PICTURE *image);
void get_virtual_image(PICTURE *Image, int wvtDecompLev, 
		       int usemask, int colors, int alphaTH, int change_CR_disable);
void get_virtual_mask(PICTURE *Image, int wvtDecompLev, 
		      int w, int h, int usemask, int colors) ;


#endif _MAIN_H_
