/* $Id: stats.c,v 1.4 1998/02/20 21:14:17 hjlee Exp $ */
/****************************************************************************/
/*   MPEG4 Visual Texture Coding (VTC) Mode Software                        */
/*                                                                          */
/*   This software was developed by                                         */
/*   Sarnoff Coporation                   and    Texas Instruments          */
/*   Iraj Sodagar   (iraj@sarnoff.com)           Jie Liang (liang@ti.com)   */
/*   Hung-Ju Lee    (hjlee@sarnoff.com)                                     */
/*   Paul Hatrack   (hatrack@sarnoff.com)                                   */
/*   Shipeng Li     (shipeng@sarnoff.com)                                   */
/*   Bing-Bing Chai (bchai@sarnoff.com)                                     */
/*                                                                          */
/* In the course of development of the MPEG-4 standard. This software       */
/* module is an implementation of a part of one or more MPEG-4 tools as     */
/* specified by the MPEG-4 standard.                                        */
/*                                                                          */
/* The copyright of this software belongs to ISO/IEC. ISO/IEC gives use     */
/* of the MPEG-4 standard free license to use this  software module or      */
/* modifications thereof for hardware or software products claiming         */
/* conformance to the MPEG-4 standard.                                      */
/*                                                                          */
/* Those intending to use this software module in hardware or software      */
/* products are advised that use may infringe existing  patents. The        */
/* original developers of this software module and their companies, the     */
/* subsequent editors and their companies, and ISO/IEC have no liability    */
/* and ISO/IEC have no liability for use of this software module or         */
/* modification thereof in an implementation.                               */
/*                                                                          */
/* Permission is granted to MPEG memebers to use, copy, modify,             */
/* and distribute the software modules ( or portions thereof )              */
/* for standardization activity within ISO/IEC JTC1/SC29/WG11.              */
/*                                                                          */
/* Copyright (C) 1998  Sarnoff Coporation and Texas Instruments             */ 
/****************************************************************************/

/************************************************************/
/*     Sarnoff Very Low Bit Rate Still Image Coder          */
/*     Copyright 1995, 1996, 1997, 1998 Sarnoff Corporation */
/************************************************************/



#include <stdio.h>
#include <math.h>
#include "dataStruct.h"
#include "globals.h"


void writeStats()
{
  int x,y,c;
  double singleErr, totSqrErr, mse, psnr;
  int numCoeff;

  noteProgress("Calculating and writing statistics....");
  
  c=mzte_codec.curColor;

  /* Write 'header' info */
  noteStat("\n----- AC Band: Spatial Layer %3d, SNR Layer %3d, Color %3d \
-----\n\n",
	   mzte_codec.curSpatialLev, mzte_codec.curSNRLev, 
	   mzte_codec.curColor);
  noteStat("Width = %5d, Height = %5d\n\n", 
	   mzte_codec.SPlayer[c].width, mzte_codec.SPlayer[c].height);

  /* Calculate statistics */
  totSqrErr=0.0;
  for (y = 0; y < mzte_codec.SPlayer[c].height; ++y)
    for (x = 0; x < mzte_codec.SPlayer[c].width; ++x)
    {
      singleErr = COEFF_ORGVAL(x,y,c)-COEFF_RECVAL(x,y,c);
      totSqrErr += singleErr*singleErr;
    }
  
  numCoeff=mzte_codec.SPlayer[c].width*mzte_codec.SPlayer[c].height;
  
  mse = totSqrErr/numCoeff;
  if (mse==0)
    noteStat("PSNR = INFINITY\n");
  else
  {
    psnr = 20*log10(255/sqrt(mse));
    noteStat("PSNR = %f\n", psnr);
  }

  noteProgress("Completed calculating and writing of statistics.");
}
