/* This code was obtained from Lehigh University/Vector Vision, Inc.. 
It was originally developed by OKI. 
Dr. Hongqiao Sun/Weiping integrated it to the Lehigh/VVI software. 

The copyrights or credits should belong to the following people and companies:

Zhixiong Wu and Yoshihiro Ueda of OKI,
Hongqiao Sun of Vector Vision,
Weiping Li of Lehigh University,

Minor modifications was made by Shipeng Li to integrated it to Sarnoff's SOL
software.
*/
#include <stdio.h>
#include <stdlib.h>
#include "ShapeUtil.h"

void *
mymalloc(size_t size)
{
    void *tmp;

    if ( (tmp=malloc(size))==NULL ) {
        fprintf(stderr,"Malloc error.\n");
        exit(1);
    }
    return(tmp);
}

unsigned char **
malloc_2d_char(int d1,int d2)
{
    unsigned char **array_2d;
    int i;

    array_2d = (unsigned char **) mymalloc(d1*sizeof(unsigned char *));
    for ( i=0; i<d1; i++ ) {
        array_2d[i] = (unsigned char *) mymalloc(d2*sizeof(unsigned char));
    }
    return(array_2d);
}

void
free_2d_char(unsigned char **array_2d,int d1)
{
    int i;

    for ( i=0; i<d1; i++ ) {
        free(array_2d[i]);
    }
    free(array_2d);
}

int **
malloc_2d_int(int d1,int d2)
{
    int **array_2d;
    int i;

    array_2d = (int **) mymalloc(d1*sizeof(int *));
    for ( i=0; i<d1; i++ ) {
        array_2d[i] = (int *) mymalloc(d2*sizeof(int));
    }
    return(array_2d);
}

void
free_2d_int(int **array_2d,int d1)
{
    int i;

    for ( i=0; i<d1; i++ ) {
        free(array_2d[i]);
    }
    free(array_2d);
}
