/* $Id: ztscan.h,v 1.4 1998/02/20 21:14:39 hjlee Exp $ */
/****************************************************************************/
/*   MPEG4 Visual Texture Coding (VTC) Mode Software                        */
/*                                                                          */
/*   This software was developed by                                         */
/*   Sarnoff Coporation                   and    Texas Instruments          */
/*   Iraj Sodagar   (iraj@sarnoff.com)           Jie Liang (liang@ti.com)   */
/*   Hung-Ju Lee    (hjlee@sarnoff.com)                                     */
/*   Paul Hatrack   (hatrack@sarnoff.com)                                   */
/*   Shipeng Li     (shipeng@sarnoff.com)                                   */
/*   Bing-Bing Chai (bchai@sarnoff.com)                                     */
/*                                                                          */
/* In the course of development of the MPEG-4 standard. This software       */
/* module is an implementation of a part of one or more MPEG-4 tools as     */
/* specified by the MPEG-4 standard.                                        */
/*                                                                          */
/* The copyright of this software belongs to ISO/IEC. ISO/IEC gives use     */
/* of the MPEG-4 standard free license to use this  software module or      */
/* modifications thereof for hardware or software products claiming         */
/* conformance to the MPEG-4 standard.                                      */
/*                                                                          */
/* Those intending to use this software module in hardware or software      */
/* products are advised that use may infringe existing  patents. The        */
/* original developers of this software module and their companies, the     */
/* subsequent editors and their companies, and ISO/IEC have no liability    */
/* and ISO/IEC have no liability for use of this software module or         */
/* modification thereof in an implementation.                               */
/*                                                                          */
/* Permission is granted to MPEG memebers to use, copy, modify,             */
/* and distribute the software modules ( or portions thereof )              */
/* for standardization activity within ISO/IEC JTC1/SC29/WG11.              */
/*                                                                          */
/* Copyright (C) 1998  Sarnoff Coporation and Texas Instruments             */ 
/****************************************************************************/

/************************************************************/
/*     Sarnoff Very Low Bit Rate Still Image Coder          */
/*     Copyright 1995, 1996, 1997, 1998 Sarnoff Corporation */
/************************************************************/

/************************************************************/
/*  Filename: ztscan.h                                      */
/*  Author: Bing-Bing Chai                                  */
/*  Date: January 29, 1998                                  */
/*                                                          */
/*  Descriptions:                                           */
/*    This is the header file for both ztscan_enc.c and     */
/*    ztscan_dec.c. Which contains the functions that will  */
/*    be called by functions in other files.                */
/*                                                          */
/************************************************************/
#ifndef _ZTSCAN_
#define _ZTSCAN_

/* encoding routines */
extern void wavelet_dc_encode(int c);
extern void wavelet_higher_bands_encode_SQ(int c);
extern void wavelet_higher_bands_encode_MQ(SNR_IMAGE *snr_image, int c);

/* decoding routines */
extern void wavelet_dc_decode(int c);
extern void wavelet_higher_bands_decode_SQ(int c);
extern void wavelet_higher_bands_decode_MQ(SNR_IMAGE *snr_image, int c);

#endif 
